\documentstyle[12pt,amstex,amssymb]{article}
\def\ga{\alpha}
\def\gb{\beta}
\def\gc{\gamma}
\def\gd{\delta}
\def\ge{\epsilon}
\def\gz{\zeta}
\def\gy{\eta}
\def\th{\theta}
\def\gi{\iota}
\def\gk{\kappa}
\def\gl{\lambda}
\def\gm{\mu}
\def\gn{\nu}
\def\gx{\xi}
\def\gp{\pi}
\def\gr{\rho}
\def\gs{\sigma}
\def\gt{\tau}
\def\gu{\upsilon}
\def\ph{\phi}
\def\ch{\chi}
\def\ps{\psi}
\def\gw{\omega}

\def\gB{\Beta}
\def\gC{\Gamma}
\def\gD{\Delta}
\def\Th{\Theta}
\def\gL{\Lambda}
\def\gX{\Xi}
\def\gP{\Pi}
\def\gS{\Sigma}
\def\gU{\Upsilon}
\def\Ph{\Phi}
\def\Ps{\Psi}
\def\gW{\Omega}

\def\bA{{\bf A}}
\def\bB{{\bf B}}
\def\bC{{\bf C}}
\def\bD{{\bf D}}
\def\bE{{\bf E}}
\def\bF{{\bf F}}
\def\bG{{\bf G}}
\def\bH{{\bf H}}
\def\bI{{\bf I}}
\def\bJ{{\bf J}}
\def\bK{{\bf K}}
\def\bL{{\bf L}}
\def\bM{{\bf M}}
\def\bN{{\bf N}}
\def\bO{{\bf O}}
\def\bP{{\bf P}}
\def\bQ{{\bf Q}}
\def\bR{{\bf R}}
\def\bS{{\bf S}}
\def\bT{{\bf T}}
\def\bU{{\bf U}}
\def\bV{{\bf V}}
\def\bW{{\bf W}}
\def\bX{{\bf X}}
\def\bY{{\bf Y}}
\def\bZ{{\bf Z}}

\def\cA{{\cal A}}
\def\cB{{\cal B}}
\def\cC{{\cal C}}
\def\cD{{\cal D}}
\def\cE{{\cal E}}
\def\cF{{\cal F}}
\def\cG{{\cal G}}
\def\cH{{\cal H}}
\def\cI{{\cal I}}
\def\cJ{{\cal J}}
\def\cK{{\cal K}}
\def\cL{{\cal L}}
\def\cM{{\cal M}}
\def\cN{{\cal N}}
\def\cO{{\cal O}}
\def\cP{{\cal P}}
\def\cQ{{\cal Q}}
\def\cR{{\cal R}}
\def\cS{{\cal S}}
\def\cT{{\cal T}}
\def\cU{{\cal U}}
\def\cV{{\cal V}}
\def\cW{{\cal W}}
\def\cX{{\cal X}}
\def\cY{{\cal Y}}
\def\cZ{{\cal Z}}


\def\ba{{\bf a}}
\def\bb{{\bf b}}
\def\bc{{\bf c}}
\def\bd{{\bf d}}
\def\be{{\bf e}}
\def\bg{{\bf g}}
\def\bh{{\bf h}}
\def\bi{{\bf i}}
\def\bj{{\bf j}}
\def\bk{{\bf k}}
\def\bl{{\bf l}}
\def\bm{{\bf m}}
\def\bn{{\bf n}}
\def\bo{{\bf o}}
\def\bp{{\bf p}}
\def\bq{{\bf q}}
\def\br{{\bf r}}
\def\bs{{\bf s}}
\def\bt{{\bf t}}
\def\bu{{\bf u}}
\def\bv{{\bf v}}
\def\bw{{\bf w}}
\def\bx{{\bf x}}
\def\by{{\bf y}}
\def\bz{{\bf z}}

\def\b0{{\bf0}}
\def\o{\circ}
\def\x{\times}
\def\d{\partial}
\def\<{\langle}
\def\>{\rangle}
\def\R{{\mathbb R}}
\def\Z{{\mathbb Z}}
\def\Q{{\mathbb Q}}
\def\N{{\mathbb N}}
\def\C{{\mathbb C}}
\def\T{{\mathbb T}}
\def\Cinf{C^\infty}
\def\sb{\subseteq}
\def\sp{\superseteq}
\def\({\left(}
\def\){\right)}
\def\rank{\mbox{rank}\,}
\def\rk{\mbox{rank}\,}
\def\ddt{\frac d{dt}}
\def\corank{\mbox{corank}\,}
\def\cl{\hbox{cl}\,}
\def\im{\hbox{im}\,}
\def\Id{\hbox{Id}}
\def\Diff{\hbox{Diff}}
\def\tv{\pitchfork}
\def\ntv{\not\tv}
\def\codim{\hbox{codim}\,}
\def\tr{\hbox{tr}\,}
\def\cosec{\hbox{cosec}\,}
\def\const{\hbox{const}}
\def\lc{\lceil}
\def\rc{\rceil}
\def\lf{\lfloor}
\def\rf{\rfloor}
\def\sech{\hbox{sech}\,}
\def\csch{\hbox{csch}\,}
\def\grad{\hbox{grad}\,}
\def\nbhd{neighbourhood}
\def\dlim{\displaystyle\lim}
\def\dfrac#1#2{\displaystyle{#1\over#2}}
\def\dsum{\displaystyle\sum}
\def\dint{\displaystyle\int}
\def\diint{\displaystyle\iint}
\def\diiint{\displaystyle\iiint}
\def\doint{\displaystyle\oint}
\def\tlim{\textstyle\lim}
\def\tfrac#1#2{\textstyle{#1\over#2}}
\def\tsum{\textstyle\sum}
\def\tint{\textstyle\int}
\def\del{\nabla}
\def\div{\hbox{div}\,}
\def\curl{\hbox{curl}\,}
\def\intL{\int\limits}
\def\iintL{\iint\limits}
\def\iiintL{\iiint\limits}

\def\abs{\hbox{abs}\,}
\def\sgn{\hbox{sgn}\,}
\def\dom{\hbox{dom}\,}


\def\eval{\,\Bigl.\Bigl|}



\def\drawbox#1{\lower6pt\hbox{{\vbox{\hrule\hbox{\vrule\kern15pt
   \vbox{\kern10pt\vbox{\hbox{#1}}\kern10pt} 
   \kern18pt\vrule}\hrule}}}}

\def\picture #1 by #2 (#3){
  \medbreak
		$$\vbox to #2{
    \hrule width #1 height 0pt depth 0pt
    \vfill
    \special{picture #3}
  }$$
}

\def\scaledpicture #1 by #2 (#3 scaled #4){
  \dimen0=#1 
		\dimen1=#2
  \divide\dimen0 by 1000 
   \multiply\dimen0 by #4
  \divide\dimen1 by 1000 
   \multiply\dimen1 by #4
  \picture \dimen0 by \dimen1 (#3 scaled #4)}
%\input mypars
%The following are plain tex style parameters 

\baselineskip=12pt
\hoffset=0pt
\voffset=0 cm
\leftskip=0pt
\rightskip=0pt
\parindent=0cm

%And these are latex style parameters

\headsep=0cm
\headheight=0cm
\evensidemargin=0cm
\oddsidemargin=0cm
\parskip=12pt
\textwidth=16.5 true cm
\textheight=22 true cm
\topmargin=1cm

\def\Gr{Gr\"obner}
\def\kn{k[x_1,\dots,x_n]}
\def\lc{{\sc lc}}
\def\lt{{\sc lt}}
\def\lp{{\sc lt}}
\def\gcd{{\sc gcd}}

\newtheorem{theorem}{Theorem}
\newtheorem{lemma}{Lemma}[section]
\newtheorem{definition}{Definition}[section]
\newtheorem{example}{Example}[section]
\newtheorem{corollary}[theorem]{Corollary}


\newenvironment{proof}
{\begin{trivlist}
\item[\hskip \labelsep {\bf Proof.}]
}
{\hfill$\Box$
\end{trivlist}}
           

\def\pagenumbers{\headline={\iftitle\hfil\global\titlefalse                     
   \else\hss\rm\folio\hss\fi}}                                                  
\newtoks\option                                                                 
\newtoks\solnhead                                                               
\newtoks\sheetname                                                              
\option={,}                                                                     
\def\separate#1,#2@{\def\optionid{#1}\def\optionname{#2}}                      
\def\fullwidth{\everypar{}\parindent=0pt\relax}                                 

\def\maketitle{
\begin{center}
{\sc Victoria University of Wellington\\
School of Mathematics, Statistics and Operations Research}\\
\smallskip
{\sl
Te Kura M{\=a}tai Tatauranga, Rangahau P{\=u}naha}
\end{center}
\expandafter\separate\the\option@
\hbox to\hsize{\hrulefill}
\nointerlineskip
\vskip3pt                                  
\hbox
to\hsize{\strut\rlap{\optionid}\hfill{\sc\optionname}\hfill\llap{\number\year}}          
\nointerlineskip
\vskip2pt
\hbox to\hsize{\hrulefill}}

\let\filbreak=\relax                                                           
\def\head{\filbreak\vskip 18pt\fullwidth                                    
   \def\filbreak{\global\let\filbreak=\fillbreak}%                            
   \centerline{\large\bf \the\sheetname}\nobreak
   \vskip 12pt minus 3pt}                                                       
\def\tutorial{\sheetname={Tutorial}\head}                                      
\def\assignment{\sheetname={Assignment}\head}                                  
\def\sheet#1{\sheetname={#1}\head}                                             
\def\showdue#1{\hbox to\hsize{\hfil Due: #1}
\vskip 5pt minus 3pt}

\leftmargin=0pt              

\begin{document}

\option={MATH 437,Gr\"obner Bases and Their Applications}        
\maketitle
\medskip 
\setcounter{section}4
\section{Term Orders}



\subsection{Solving linear equations}

Having explored division for polynomials of one variable, we now need to consider multivariate polynomials.  One situation where division arises is in the solution of linear equations, though this may not be immediately obvious.  Let's work
with a particular example:
\begin{eqnarray*}
f_1=x+y-z&=&0\\
f_2=2x+3y+2z&=&0.
\end{eqnarray*}
Row reduction on the coefficient matrix, via $R_2-2R_1$, gives us:
$$
\left[\begin{array}{ccc}
1&1&-1\\
2&3&2
\end{array}\right]
\rightarrow
\left[\begin{array}{ccc}
1&1&-1\\
0&1&4
\end{array}\right].
$$
Equivalently, then the equations can be solved by solving:
\begin{eqnarray*}
f_1=x+y-z&=&0\\
f_3=y+4z&=&0
\end{eqnarray*}
which can be done by, for example, choosing $z$ as a parameter and letting $x=5z$,
$y=-4z$.

Now the solution set is $V(f_1,f_2)$. Our row reduction amounts to introducing
$f_3=f_2-2f_1\in\<f_1,f_2\>$ and we assert that $\<f_1,f_3\>=\<f_1,f_2\>$, whence
$V(f_1,f_3)=V(f_1,f_2)$, from which it is easier to determine the solution set. The
equality of the ideals is a simple exercise: show that each is a subset of the
other.

What underlies this simplification process? It's really just a matter of deciding
how to combine rows to eliminate variables. This can be thought of as a division
process: We chose to subtract $2R_1$ from $R_2$ because if you divide $f_2$ by
$f_1$ this is the quotient:
$$
\begin{array}{cl}
&2\\
&\hrulefill\\
x+y+z&\multicolumn{1}{|l}{2x+3y+2z}\\
&2x+2y-2z\\
&\hrulefill\\
&\kern1cm y+4z
\end{array}
$$
The remainder is, of course, precisely $f_3$. We describe this {\bf reduction}
process symbolically by
$$
f_2\stackrel{f_1}{\longrightarrow}f_3.
$$

Here's a second example. Solve the equations:
$$
\begin{array}{ccrcrcrcc}
g_1&=&x&+&2y&+&3z&=&0\\
g_2&=&&&y&-&z&=&0\\
g_3&=&3x&-&4y&+&2z&=&0
\end{array}
$$
Row reduction gives us:
$$
\left[\begin{array}{ccc}
1&2&3\\
0&1&-1\\
3&-4&2
\end{array}\right]
\rightarrow
\left[\begin{array}{ccc}
1&2&3\\
0&1&-1\\
0&-10&-7
\end{array}\right]
\rightarrow
\left[\begin{array}{ccc}
1&2&3\\
0&1&-1\\
0&0&-17
\end{array}\right].
$$
Here the reduction process can be described by 
$$
g_3\stackrel{g_1}{\longrightarrow}-10y-7z\stackrel{g_2}{\longrightarrow}-17z.
$$
or more succinctly:
$$
g_3\stackrel{g_1,g_2}{\longrightarrow}_+-17z.
$$

In algebraic terms, the remainder $-17z$ can be seen as indicating the extent to
which $g_3$ fails to belong to the ideal generated by $g_1,g_2$.  Indeed, we can
say that 
$$
f\in\<g_1,g_2\>\iff f\stackrel{g_1,g_2}{\longrightarrow}_+0.
$$

Another approach is to recall that if $I\subset R$ is an ideal of a ring, then we
may define a congruence $\mod I$ by $f\equiv g\mod I$ if $g-f\in I$. The set of
cosets form a {\bf quotient ring} $R/I$ whose elements are cosets $f+I$. In
effect, what we showed above is that quotient ring $\Q[x,y,z]/\<g_1,g_2\>$ is
generated by the coset of $z$, or alternatively that it is spanned as a vector
space (over $\Q$) by the powers of $z$.

To summarise the process, we have chosen an {\it order\/} on the variables, namely
$x>y>z$. Had we chosen a different order, we would have eliminated different terms
from equations. Given that order, we have {\it reduced\/} the equations by a process
involving division by the {\it leading\/} terms.

\subsection{Term orders}

We considered both linear equations in several variables and polynomials in one
variable with a view to understanding how a given set of equations (basis for an
ideal) could be reduced to one that was more amenable to solution.  In the case of
univariate polynomials we saw that the Division Algorithm enables one to reduce the
basis to a single polynomial, namely the {\gcd} of the given set. In the linear
case, Gaussian reduction enabled the elimination of variables.

What are the ingredients we need for a similar reduction process for sets of
multivariate polynomials? We want:
\begin{itemize}
\item 
a division process to
\begin{itemize}
\item
simplify bases
\item
determine ideal membership
\end{itemize}
\item
an ordering of terms to
\begin{itemize}
\item
provide structure for the division process
\item
ensure the division process terminates
\end{itemize}
\end{itemize}

Recall we used the term orders $x>y>z$ in the linear case and $1<x<x^2<\dots$ in
the univariate case.  The first of these was really arbitrary but the second is
crucial in ensuring the termination of the division algorithm.

Let $\T^n=\{x_1^{\ga_1}\dots x_n^{\ga_n}\in\kn\,:\,\ga_i\in\N\}$ be the set of {\it
monomials\/} or {\it monic terms\/}. We abbreviate these as $x^\ga$ where
$\ga=(\ga_1,\dots,\ga_n)\in\N^n$. Recall that the {\it degree\/} of $x^\ga$
is given by $|\ga|=\sum\ga_i$. Essential ingredients for an ordering of the terms
are:
\begin{itemize}
\item
if $x^\ga$ divides $x^\gb$ then $x^\ga\leq x^\gb$.
\item
it should be a total order: for any terms $x^\ga, x^\gb$, either $x^\ga<x^\gb$,
$x^\ga=x^\gb$ or $x^\ga>x^\gb$ (i.e. all terms are comparable).
\item
it should be a well ordering (no infinitely descending chains) to ensure
termination of algorithms.
\end{itemize}

It turns out that these properties are neatly encapsulated by the following:

\begin{definition}
$<$  is a {\bf term order} on $\T^n$ if 
\begin{enumerate}
\item
it is a total order
\item
for all $x^\ga\neq1$, $1<x^\ga$
\item
if $x^\ga<x^\gb$ then for all $x^\gc\in\T^n$, $x^\ga x^\gc<x^\gb x^\gc$.
\end{enumerate}
\end{definition}

\begin{lemma}
\label{div}
In any term order, $x^\ga|x^\gb$ implies $x^\ga\leq x^\gb$.
\end{lemma}

The proof is an exercise.

More important is the following property:

\begin{theorem}
Every term order of $\T^n$ is a well-ordering; that is, every non-empty subset has
a least element.
\end{theorem}

\begin{proof}
We use the Hilbert Basis Theorem.  Suppose $<$ is a term order but not
a well-order. Then there exists an infinite descending chain
$$
x^{\ga_1}>x^{\ga_2}>\dots>x^{\ga_n}>\dots
$$
Now consider the corresponding ascending chain of ideals:
$$
\<x^{\ga_1}\>\subseteq\<x^{\ga_1},x^{\ga_2}\>\subseteq\dots\subseteq\<x^{\ga_1},
\dots,x^{\ga_n}\>\subseteq\dots
$$
By the Hilbert Basis Theorem, this must terminate, so there is an $r$ for which
$$
\<x^{\ga_1},\dots,x^{\ga_r}\>=\<x^{\ga_1},\dots,x^{\ga_{r+1}}\>.
$$
Hence
\begin{equation}
\label{highterm}
x^{\ga_{r+1}}=\sum_{i=1}^ru_ix^{\ga_i},\kern1cm u_i\in\kn.
\end{equation}
Now each $u_i=\dsum_{j=1}^pa_{ij}x^{\ga_{ij}}$ where $a_{ij}\in k$. Therefore, in
equation~(\ref{highterm}), each term on the right is of the form 
$a_{ij}x^{\ga_{ij}}x^{\ga_i}$ for some $1\leq i\leq n$ and hence is divisible by
$x^{\ga_i}$. 

On the other hand the left-hand side of equation~(\ref{highterm}) is a single term
(other terms in the the sum must cancel) and so is divisible by some $x^{\ga_k}$,
$1\leq k\leq n$. Then by Lemma~\ref{div}, $x^{\ga_k}\leq x^{\ga_{r+1}}$, but this
contradicts our assumption.
\end{proof}



\fbox{Lexicographic order}

The idea is to think of the powers on the variables forming a ``word" in a
dictionary. The ``alphabet" is the natural numbers.  All words have $n$
letters and they appear in their natural order.

Define
$x^\ga<x^\gb\iff
\exists\,l$,
$1\leq l\leq n$ such that for $i<l$, $\ga_i=\gb_i$ and $\ga_l<\gb_l$. This is
denoted {\sc lex}. 

An immediate consequence of the definition is that $x_1>x_2>\dots>x_n$, since, for
example, the ``word" for $x_1$ is $100\dots0$ while that for $x_2$ is $010\dots0$. 

In $k[x,y]$ for example, with $x>y$,
$$
\begin{array}{cll}
1&<y<y^2<y^3\dots&\mbox{all terms in $x^0$}\\
&\dots<x<xy<xy^2<\dots&\mbox{all terms in $x^1$}\\
&\dots<x^2<x^2y<x^2y^2<\dots&\mbox{all terms in $x^2$}
\end{array}
$$
Notice that the terms are {\it not\/} ordered by degree.




\fbox{Degree lexicographic order}

Here we use degree is the first way of discriminating order, then use
lexicographic order as a tie-breaker.

Define
$x^\ga<x^\gb\iff |\ga|<|\gb|$ or
$|\ga|=|\gb|$ and
$x^\ga<_{\sc lex}x^\gb$. This is denoted {\sc deglex}.

Again $x_1>x_2>\dots>x_n$ as these all have degree~1.   In $k[x,y]$ with $x>y$,
$$
\begin{array}{cl}
\mbox{degree}&\\
0&1<\\
1&y<x<\\
2&y^2<xy<x^2<\\
3&y^3<xy^2<x^2y<x^3<\\
\vdots&\cdots
\end{array}
$$


\fbox{Degree reverse lexicographic order}

As {\sc deglex} but replace the {\sc lex} order within degree by {\it reverse\/}
{\sc lex} order: if $|\ga|=|\gb|$ then there exists $r$, $1\leq r\leq n$ such that
for all $i>r$, $\ga_i=\gb_i$ and $\ga_r>\gb_r$. This is denoted {\sc degrevlex}.

Whereas in {\sc deglex} the earlier
(and hence greater) $x_i$s only appear later in the listing, in {\sc degrevlex} we
work through all the terms for a {\it fixed\/} power of a lower variable first. It
is still the case that $x_1>x_2>\dots>x_n$. {\sc Degrevlex} is the same as {\sc
lex} in $\kn$ for
$n=1,2$ but for $n=3$ and terms of degree~3, say, we have:
\begin{eqnarray*}
{\sc deglex}:&&
x_3^3<x_2x_3^2<x_2^2x_3<x_2^3<x_1x_3^2<x_1x_2x_3<\dots\\
{\sc degrevlex}:&&
x_3^3<x_2x_3^2<x_1x_3^2<x_2^2x_3<x_1x_2x_3<x_1^2x_3<\dots
\end{eqnarray*}


\end{document}



